package prefuse.KirstenProject;

import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.imageio.*;
import java.awt.BorderLayout;

import edu.berkeley.guir.prefuse.graph.Entity;
import edu.berkeley.guir.prefuse.graph.Node;
import edu.berkeley.guir.prefuse.ItemRegistry;
import edu.berkeley.guir.prefuse.NodeItem;
import edu.berkeley.guir.prefuse.VisualItem;

import java.awt.Color;
import java.awt.image.*;
import java.net.URL;
import java.io.*;
import java.util.*;
import javax.swing.ImageIcon;

import edu.berkeley.guir.prefuse.graph.Entity;
import edu.berkeley.guir.prefuse.graph.Node;

public class DetailsPanel extends JPanel {
	KirstenProject proj;
	private JLabel userLabel;
	private JLabel iconLabel;
	private JTextArea featuresLabel;
	private JScrollPane scroller;
	private Pair lastFeaturePair;
	private HashMap userToFeaturesMap = null;
	
	
	public void initUserToFeaturesMap() {
		lastFeaturePair = proj.currentFeaturePair;
		if( userToFeaturesMap == null )
			userToFeaturesMap = new HashMap();
		else
			userToFeaturesMap.clear();
		HashMap m = (HashMap) proj.allFeaturesMap.get( lastFeaturePair.getSecond() );
		Iterator iter = m.keySet().iterator();
		while( iter.hasNext() ) {
			String feature = (String) iter.next();
			List usersWithThisFeature = (List) m.get( feature );
			Iterator iter2 = usersWithThisFeature.iterator();
			while( iter2.hasNext() ) {
				String userWithThisFeature = (String) iter2.next();
				List userEntries = (List) userToFeaturesMap.get( userWithThisFeature );
				if( userEntries == null )
					userEntries = new ArrayList();
				userToFeaturesMap.put( userWithThisFeature, userEntries );
				userEntries.add( feature );
			}
		}
	}
	public void updateDetails( String user ) {
		if( proj.highlightedItems.size() != 0 ) {
			if( userToFeaturesMap == null
					|| !proj.currentFeaturePair.equals( lastFeaturePair )) {
				initUserToFeaturesMap();
			}
			Iterator iter0 = proj.highlightedItems.iterator();
			String userText = "";
			while( iter0.hasNext() ) {
				VisualItem i = (VisualItem) iter0.next();
				Entity e = proj.m_registry.getEntity( i );
            	String r = ((Node) e).getAttribute("label");
            
				userText += r + ", ";
			}
			userLabel.setText( userText );
			Iterator iter = proj.highlightedItems.iterator();
			HashSet interestsToShow = new HashSet();
			while( iter.hasNext() ) {			
				VisualItem highlightedItem = (VisualItem) iter.next();
				Entity e = proj.m_registry.getEntity( highlightedItem );
            	String highlightedUser = ((Node) e).getAttribute("label");
            	List userFeatures = (List)userToFeaturesMap.get( highlightedUser );
            	if( userFeatures != null )
            		interestsToShow.addAll( userFeatures );
			}
			iter = proj.highlightedItems.iterator();
			while( iter.hasNext() ) {
				VisualItem highlightedItem = (VisualItem) iter.next();
				Entity e = proj.m_registry.getEntity( highlightedItem );
            	String highlightedUser = ((Node) e).getAttribute("label");
            	List userFeatures = (List)userToFeaturesMap.get( highlightedUser );
            	if( userFeatures != null )
            		interestsToShow.retainAll( userFeatures );
        		
			}
			Iterator iter2 = interestsToShow.iterator();
			String res = "";
			System.out.println( "interestsToShow = " + interestsToShow );
			while( iter2.hasNext() ) {
				String nextInt = (String) iter2.next();
				res += nextInt + "\n";
			}
			featuresLabel.setText( res );
		}
		else {
		userLabel.setText( user );
		String userpicUrl = (String) proj.userpicMap.get( user );
		System.out.println( "userpicUrl = " + userpicUrl );
		if( userpicUrl != null ) {
			try {
			ImageIcon img = new ImageIcon( userpicUrl );
			System.out.println("img = " + img );
			iconLabel.setIcon( img );
			System.out.println( "loadStatus = " + img.getImageLoadStatus() );
			} catch( Exception e ) { return; }
			
		}
		String userFeaturesInCluster = "";
		System.out.println( "userToCluster = " + proj.userToCluster );
		HashMap m = (HashMap) proj.userToCluster.get( proj.currentFeaturePair.toString() );
		System.out.println( "m = " + m );
		Integer clusterId = (Integer) m.get( user );
		System.out.println( "clusterId = " + clusterId );
		Pair p = new Pair( clusterId, 
				proj.currentFeaturePair.getSecond() );
		System.out.println( "featureMap = " + proj.featureMap );
		System.out.println( "featPair = " + p );
		HashMap featureMap = (HashMap) proj.featureMap.get( p.toString() );
		Set clusterFeatures = featureMap.keySet();
		HashMap userFeatureMap = (HashMap) proj.allFeaturesMap.get( proj.currentFeaturePair.getSecond() );
		Set userFeatures = userFeatureMap.keySet();
		//System.out.println( "clusterFeatures = " + clusterFeatures );
		//System.out.println( "userFeatures = " + userFeatures );
		Iterator iter = clusterFeatures.iterator();
		while( iter.hasNext()) {
			String nextInterest = (String) iter.next();
			//System.out.println ("nextInterest = " + nextInterest );
			String toLookup = nextInterest.split( ",")[0];
			List res = (List) 
			    userFeatureMap.get( toLookup );
			if( res != null && res.contains( user ) ) {
				userFeaturesInCluster += toLookup + "\n";
			}
		}
		featuresLabel.setText( userFeaturesInCluster );
		}
	}
	
	
	public DetailsPanel( KirstenProject p ) {
		proj = p;
		lastFeaturePair = proj.currentFeaturePair;
		this.setBackground(Color.WHITE);
	    initUI();
	}
	
	private void initUI() {
        this.setLayout(new BorderLayout());
       
        userLabel = new JLabel( "Dongs");
        this.add( userLabel, BorderLayout.NORTH );
        
     
        
        this.add(Box.createVerticalGlue());
        iconLabel = new JLabel();
        this.add( iconLabel, BorderLayout.WEST );
        featuresLabel = new JTextArea("", 12, 18);
        scroller = new JScrollPane( featuresLabel );
        this.add( scroller, BorderLayout.EAST );
    } //
}
