package prefuse.KirstenProject;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.util.*;
import java.io.*;
import java.awt.Point;

import javax.swing.AbstractAction;
import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
public class InterestsPanel  extends JPanel {
	
	

	/**
	 * A Swing user interface component that shows data
	 * about interests shared by users in a cluster when
	 * the user mouses over nodes in that cluster.
	 */
		
	JLabel userLabel;
	JLabel clusterLabel;
	JTextArea interestsLabel;
	KirstenProject proj;
	HashMap userToCluster;
    HashMap clusterIdToUsers;
    JScrollPane scroller;
    boolean enabled = true;
    
    public void setEnabled( boolean b) {
    	enabled = b;
    }
	public void updateInterests( String user ) {
		// if clustering by interests, list interests
		// else, list members of current cluster
		userLabel.setText( user );
		HashMap m1 = (HashMap) userToCluster.get( proj.currentFeaturePair.toString() );
		Integer clusterId = ((Integer) m1.get( user));
		if( clusterId != null ) {
		clusterLabel.setText( clusterId.toString() );
	//	System.out.println( "clusterId = " + clusterId );
		HashMap featuresMap = (HashMap) proj.featureMap.get( new Pair(clusterId, proj.currentFeaturePair.getSecond() ).toString() );
	//	System.out.println( featuresMap.toString() );
		Iterator iter = featuresMap.keySet().iterator();
		boolean firstTime = true;
		HashMap numMap = new HashMap();
		int minNum = Integer.MAX_VALUE;
		int maxNum = 0;
		String text = "";
		while( iter.hasNext() ) {
			String featureName = (String) iter.next();
			List userList = (List) featuresMap.get( featureName );
			int num = userList.size();
			if( num < minNum )
				minNum = num;
			if( num > maxNum )
				maxNum = num;
			String s = ( firstTime ? "" : "\n" ) + "(" + num + ") " + featureName; 
		//	System.out.println("Putting " + num + " and " + s);
			List lst = (List) numMap.get( new Integer( num ));
			if( lst == null )
				lst = new ArrayList();
			lst.add( s );
			numMap.put( new Integer( num ), lst );
			if( firstTime )
				firstTime = false;
		}
		//System.out.println( "minNum = " + minNum + " maxNum = " + maxNum );
		
		for( int i = maxNum; i >= minNum; i-- ) {
			Object res = numMap.get( new Integer( i ));
			if( res != null ) {
			text += ((List)res ).toString();
			//System.out.println( "new text = " + text);
			}
		}
 		interestsLabel.setSize( 100, 200 );
		interestsLabel.setLineWrap( true );
		interestsLabel.setText( text );
		}
		proj.dpanel.updateDetails( user );
	}
	    public InterestsPanel(HashMap utc, HashMap ctu, KirstenProject p) {
	    	userToCluster = utc;
	    	clusterIdToUsers = ctu;
	    	proj = p;
	        this.setBackground(Color.WHITE);
	        initUI();
	        

	   } //
	    
	    private void initUI() {
	        this.setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
	       
	        userLabel = new JLabel( "");
	     /*   for ( int i=0; i<forces.length; i++ ) {
	            Force f = forces[i];
	            Box v = new Box(BoxLayout.Y_AXIS);
	            for ( int j=0; j<f.getParameterCount(); j++ ) {
	                v.add(createField(f,j));
	            }
	            String name = f.getClass().getName();
	            name = name.substring(name.lastIndexOf(".")+1);
	            v.setBorder(BorderFactory.createTitledBorder(name));
	            this.add(v);
	        }*/
	        this.add( userLabel );
	        clusterLabel = new JLabel( "");
	        this.add( clusterLabel );
	        interestsLabel = new JTextArea( "", 12, 18);
	        scroller = ( new JScrollPane( interestsLabel ) );
	        this.add( scroller );
	        
	        this.add(Box.createVerticalGlue());
	    } //
	    
	    public String getInterestsInfo( List users ) {
	    	HashMap intsMap = new HashMap();
	    	Iterator iter = users.iterator();
	    	while( iter.hasNext() ) {
	    		String user = (String)iter.next();
	    		List interests = getInterests( user );
	    		Iterator intsIter = interests.iterator();
	    		while( intsIter.hasNext()) {
	    			String nextInterest = (String) intsIter.next();
	    			Integer count = (Integer) intsMap.get( nextInterest );
	    			if( count == null )
	    				intsMap.put( nextInterest, new Integer(1) );
	    			else
	    				intsMap.put(  nextInterest, new Integer( count.intValue()+1  ) );
	    		}
	    	}
	    	SortedSet s = new TreeSet(intsMap.keySet());
	    	Iterator sIter = s.iterator();
	    	SortedSet res1 = new TreeSet();
	    	while( sIter.hasNext()) {
	    		String interest = (String) sIter.next();
	    		Integer num = (Integer) intsMap.get( interest );
	    		//if( num.intValue() > 1 )
	    			res1.add("(" + ((num.toString())) + ") " + interest);
	    		
	    	}
	    	String res = "";
	    	int done = 0; int max = 10;
	    	while( res1.size() > 0 && done < max) {
	    		String str = (String) res1.last();
	    		res += str + "\n";
	    		res1.remove( str );
	    		done++;
	    	}
	    	return res;
	    	
	    }
	    public List getInterests( String user ){
	    	List res = null;
	    	try {
	    	// TODO: should cache.
	    	String fileName = "/ProjCache/www.livejournal.com/misc/interestdata.bml?user=" + user;
	    	System.out.println("Reading file " + fileName);
	    	BufferedReader br = new BufferedReader(new FileReader( fileName ));
	    	String line;
	    	//get rid of 2 comment lines at the beginning
	    	br.readLine();
	    	br.readLine();
	    	res = new ArrayList();
	    	while( (line = br.readLine()) != null ) {
	    		if( line.length() > 0 ) {
	    		int spaceInd1 = line.indexOf( " ");
	    		String substr = line.substring( spaceInd1+1, line.length());
	    		int spaceInd2 = substr.indexOf( " ");
	    		System.out.println( "line = " + line + " spaceInd1 = " + spaceInd1 +
	    				" spaceInd2 = " + spaceInd2 + " substr = " + substr);
	    		res.add( substr.substring( spaceInd2, substr.length() ) );
	    		}
	    	}
	    	
	    	} catch( Exception e ) 
	    	{ System.out.println( e.toString() ); };
	    	System.out.println( "Returning " + res.toString());
	    	return res;
	    	
	    }
}
